/*
    CDROM Low level functions
  ================================================================
  This code is done for making an easy conversion to plugin format
  ================================================================
*/
#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "type.h"
#include "Win32Def.h"
#include "Cd.h"
#include "locals.h"

#define INT2BCD(a)        ((a/10)*16+(a%10))
#define BCD2INT(a)        ((a>>4)*10+(a&0xf))

HMODULE CdrDLL;
static int error = 0;

long (*CDRinit)();
long (*CDRshutdown)();
long (*CDRopen)();
long (*CDRclose)();

long (*CDRgetTN)();
long (*CDRgetTD)();
long (*CDRreadTrack)();
long (*CDRgetBuffer)();

long (*CDRconfigure)();
long (*CDRtest)();
long (*CDRabout)();

long (*PSEgetLibName)();
long (*PSEgetLibType)();
long (*PSEgetLibVersion)();

// return NULL if something was wrong
UINT8 *CD_Read(UINT8 *param)
{
    UINT8 buf[8];

    buf[0] = INT2BCD(param[0]);
    buf[1] = INT2BCD(param[1]);
    buf[2] = INT2BCD(param[2]);

/*
    printf("read=%02x:%02x:%02x - Sector %08x\n",
            buf[0],buf[1],buf[2],
            param[0]*60*75 + param[1]*75 + param[2] - 150);
*/

    CDRreadTrack(buf);
#ifdef __GNUC__
    asm (" subl $4,%esp ");
#endif
    return (UINT8 *)CDRgetBuffer();
}

// stop playing CDA
int CD_Stop(void)
{
    return 0;
}

// Play CDA at given loc
int CD_Play(UINT8 *param)
{
    return 0;
}

// Return Track specs
int CD_GetTD(UINT8 *result,int track)
{
    CDRgetTD(track,result+1);
#ifdef __GNUC__
    asm (" subl $8,%esp ");
#endif
    result[1] = BCD2INT(result[1]);
    result[2] = BCD2INT(result[2]);
    result[3] = BCD2INT(result[3]);

    return 0;
}

// Get track number
int CD_GetTN(UINT8 *result)
{
    CDRgetTN(result+1);
#ifdef __GNUC__
    asm (" subl $4,%esp ");
#endif
    result[1] = BCD2INT(result[1]);
    result[2] = BCD2INT(result[2]);
    result[3] = BCD2INT(result[3]);

    return 0;
}

// init the CD hardware
int CD_Open(UINT32 *par)
{
    FPSEWin32 *g = (FPSEWin32 *)par;
    char       buf[256];
    char       nf[64];

    GetActiveDir(g->HInstance);
    strcpy(buf,LocalPath);
    strcat(buf,"PLUGIN\\PSEMU\\");
    g->ReadCfg("CDRPSEMU","PluginName",nf);
    strcat(buf,nf);
    if (LoadPlugin(buf) != FPSE_OK) return FPSE_ERR;

    CDRinit();
    CDRopen();

    return FPSE_OK;
}

// shutdown...
void CD_Close(void)
{
    CDRshutdown();
    CDRclose();
    FreeLibrary(CdrDLL);
}

// check end operation (with it busmaster is great!)
int CD_Wait(void)
{
    if (error)
    {
        error = 0;
        return FPSE_ERR;
    }

    return FPSE_OK;
}

// Return the seek position during CDA play
void CD_GetSeek(UINT8 *par)
{

}
